#include <bits/stdc++.h>

typedef long long ll;

using namespace std;

int main(){
    ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    string s;
    ll n,c,q;// n je velicina stringa, c je cena da se preokrene segment, q je broj operacija

    cin>>n>>c>>q;
    cin>>s;

    vector<pair<ll,ll>> v(q);
    vector<string> v1(q);

    for(int i=0;i<q;i++){
        cin>>v[i].first;
        cin>>v[i].second;
    }
    ll jedinice, nule, br;
    for(int i=0;i<q;i++){
            nule=0;
            jedinice=0;
        for(int j=v[i].first-1;j<v[i].second;j++){
                //cout<<j<<" ";
            if(s[j]=='1')
                s[j]='0';
            else
                s[j]='1';
            //cout<<s<<"\n";
        }

        for(int j=0;j<n;j++){
            if(s[j]=='1') jedinice++;
            else nule++;
        }
        if(c==1 && jedinice > nule){
            br=c+nule;
            cout<<br<<"\n";
        }
        if(c==1 && jedinice < nule){
                //br=jedinice;
                cout<< jedinice <<"\n";
        }
        if(c==n){
            cout<<jedinice<<"\n";
        }


    }


    return 0;
}